package ru.redguy.dynamicshop;

import net.milkbowl.vault.economy.Economy;
import org.bukkit.configuration.serialization.ConfigurationSerialization;
import org.bukkit.plugin.RegisteredServiceProvider;
import org.bukkit.plugin.java.JavaPlugin;
import ru.redguy.dynamicshop.api.ShopItem;
import ru.redguy.dynamicshop.commands.AddShopItemCommand;
import ru.redguy.dynamicshop.commands.ShopCommand;

public final class DynamicShop extends JavaPlugin {

    static {
        ConfigurationSerialization.registerClass(ShopItem.class, "ShopItem");
    }

    private static DynamicShop instance;

    public static DynamicShop getInstance() {
        return instance;
    }

    public Economy econ;

    @Override
    public void onEnable() {
        instance = this;
        getConfig().set("init",true);
        saveConfig();
        if(!setupEconomy()) {
            getLogger().warning("Cannot find economy!");
        }
        getServer().getCommandMap().register("shop","shop",new ShopCommand("shop"));
        getServer().getCommandMap().register("additem","shop",new AddShopItemCommand("additem"));
        getServer().getCommandMap().register("reloadshop","shop",new AddShopItemCommand("reloadshop"));
    }

    @Override
    public void onDisable() {

    }

    private boolean setupEconomy() {
        if (getServer().getPluginManager().getPlugin("Vault") == null) {
            return false;
        }
        RegisteredServiceProvider<Economy> rsp = getServer().getServicesManager().getRegistration(Economy.class);
        if (rsp == null) {
            return false;
        }
        econ = rsp.getProvider();
        return true;
    }
}
